<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;

/**
 * Class ZoznamPoctuKontrolSObratom
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class ZoznamPoctuKontrolSObratom extends ZoznamPoctuKontrolAbstract implements ZoznamPoctuKontrol
{
    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrol $pocetKontrol
     *
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolSObratom
     */
    public function add(PocetKontrol $pocetKontrol): self
    {
        $addNewRecord = true;

        if (!$pocetKontrol instanceof PocetKontrolSObratom) {
            throw new InvalidArgumentException(
                sprintf(
                    'Ocakava sa instancia triedy %s, vtupny atribut je instancie %s',
                    PocetKontrolSObratom::class,
                    get_class($pocetKontrol)
                )
            );
        }

        array_walk(
            $this->items,
            function (?PocetKontrolSObratom &$pocetKontrolPodlaObratu, int $index) use ($pocetKontrol, &$addNewRecord) {
                $pocetKontrolPodlaObratu = $pocetKontrolPodlaObratu->navysitPocetAObrat($pocetKontrol);
                $addNewRecord = false;
            }
        );

        if ($addNewRecord) {
            $this->items[] = $pocetKontrol;
        }

        return new self($this->items);
    }

    /**
     * @param array $udaje
     *
     * @return self
     */
    public static function createFromArray(array $udaje): self
    {
        $zoznam = new self();

        foreach ($udaje as $udaj) {
            $zoznam->add(new PocetKontrolSObratom(
                (float) $udaj['obrat'],
                (int) $udaj['pocet']
            ));
        };

        return $zoznam;
    }
}
